"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var react_1 = require("react");
var querystring_1 = __importDefault(require("querystring"));
var navigation_1 = require("next/navigation");
function useQueryState(defaultQuery) {
    var router = (0, navigation_1.useRouter)();
    var _a = (0, react_1.useState)(defaultQuery), queryState = _a[0], setQueryState = _a[1];
    var queryToString = function (q) {
        var query = __assign({}, q);
        // Remove defaults
        for (var key in query) {
            if (query[key] === defaultQuery[key]) {
                delete query[key];
            }
        }
        return "?" + querystring_1.default.stringify(query);
    };
    var pathWithQuery = (0, navigation_1.usePathname)() + queryToString(queryState);
    (0, react_1.useEffect)(function () {
        router.push(pathWithQuery);
    }, [pathWithQuery]);
    // Set initial state from query string
    (0, react_1.useEffect)(function () {
        setQueryState(__assign(__assign({}, defaultQuery), querystring_1.default.parse(window.location.search.slice(1))));
    }, []);
    return [queryState, setQueryState];
}
exports.default = useQueryState;
//# sourceMappingURL=index.js.map